//	L[͕
//	
//	H}U[ɕtĂ4̃^NgSWDIP8̓
//	  DIP		P2-0`7
//	  ^NgSW	P4-4`7
//
//	`^OĎpITU CH11msJE^gpĂ
//
#include <300H/3048S.H>
#include <stdio.h>
#include <sysio.h>
#include "mb_test.h"
#include "key_c.h"

unsigned char g_DIP;	// DIP
unsigned char g_SW;		// ^NgSW

int g_nDIPms;	// `^OĎ^C}(DIP)
int g_nSWms;	// `^OĎ^C}(^NgSW)

#define SW_MASK		0xF0;

// `^OĎ(ms)
#define DIP_CH_MS		30
#define SW_CH_MS		20

void InitKey()
{
	// |[g2 (DIP 1`8  P2-0`7)
	P2.DDR = 0x00;					// ALL͂ɐݒ
	P2.PCR.BYTE = 0xFF;				// vAbv
	g_DIP = P2.DR.BYTE;
	g_nDIPms = -1;

	// |[g4 (^NgSW S1`S4  P4-4`7)
	P4.DDR = 0x00;					// ͂ɐݒ
	P4.PCR.BYTE = 0xFF;				// vAbv
	g_SW = P4.DR.BYTE & SW_MASK;
	g_nSWms = -1;

	// ITU1ݒ  1ms^C}
	ITU1.TCR.BYTE = 0x23;		// ^C}Rg[WX^
								// 0010-0011 (0x23)
								// |||| |+++- TPSC  (3=NbN : /8ŃJEg)
								// |||+ +---- CKEG  (0=オGbWŃJEg)
								// |++- ----- CCLR  (1=GRARyA}b`ŃNA)
								// +--- ----- U[u
	ITU1.TSR.BYTE = 0xF8;
	ITU1.TIER.BYTE = 0xF9;		// ^C}C^vgCl[uWX^
								// 1111-1001 (0xF9)
								// |||| |||+- IMIEA (1=IMFAtO݋)
								// |||| ||+-- IMIEB (0=IMFBtO݋֎~)
								// |||| |+--- OVIE  (0=OVFtO݋֎~)
								// ++++ +---- U[u
	ITU1.TCNT = 0;
	ITU1.GRA = 2000;			// 1ms (16MHz /8)
	ITU.TSTR.BIT.STR1 = 1;
}

// DIP 1`8 (1ŉ1rbgɓ)
unsigned char GetDIP()
{
	unsigned char c = P2.DR.BYTE;
	if(g_nDIPms == -1){
		if(g_DIP != c){
			g_DIP = c;
			g_nDIPms = 0;
		}
	}
	return ~(g_DIP);
}

// SW 1`4	(1ŉ1rbgɓ)
unsigned char GetSW()
{
	unsigned char c = P4.DR.BYTE & SW_MASK;
	if(g_nSWms == -1){
		if(g_SW != c){
			g_SW = c;
			g_nSWms = 0;
		}
	}
	return ~(g_SW >> 4) & 0x0F;
}

// ITU CH1 1ms^C}
//
void interrupt Timer1ms()
{
	ITU1.TSR.BIT.IMFA = 0;
	if(g_nDIPms != -1){
		g_nDIPms++;
		if(g_nDIPms == DIP_CH_MS){
			g_nDIPms = -1;
		}
	}
	if(g_nSWms != -1){
		g_nSWms++;
		if(g_nSWms == SW_CH_MS){
			g_nSWms = -1;
		}
	}
}
