//
// VAʐMPCH8𐧌䂷
//
// Windowsp̃Av mb_test.exe gĂ
//
#include <300H/3048S.H>
#include <stdio.h>
#include <sysio.h>

#include "mb_test.h"
#include "LCD.h"
#include "sci.h"
#include "key_c.h"

void InitMPU();

// C
void main()
{
	unsigned char cDIP, cSW;
	unsigned char cDIPw, cSWw;
	
	_di();
	InitMPU();
	_ei();
	
	LCD_Clear();
	LCD_Print("H8/3048F MB_TEST", 16);
	LCD_Locate(0, 1);
	LCD_Print("SCI1 38400bps   ", 16);
	wait_ms(1000);
	LCD_Clear();
	
	cDIP = GetDIP();
	cSW = GetSW();
	
	while(1){
		// DIPXCb`ω`FbN
		cDIPw = GetDIP();
		if(cDIP != cDIPw){
			cDIP = cDIPw;
			sprintf(g_szSendBuffer, "C022%02X", (int)cDIP);
			SendCmd();
		}
		// ^NgXCb`ω`FbN
		cSWw = GetSW();
		if(cSW != cSWw){
			cSW = cSWw;
			sprintf(g_szSendBuffer, "C021%1X", (int)cSW);
			SendCmd();
		}
	}
}

// MPU
//
void InitMPU()
{
	// MPUݒ
	SYSCR.BYTE = 0x0B;				// VXeRg[WX^
									// 0000-1011 (0x0B)
									// |||| |||+- RAME  (1=RAML)
									// |||| ||+-- U[u
									// |||| |+--- NMIEG (0=GbWŊ)
									// |||| +---- UE    (1=CCR-UI[UrbgƂĎgp)
									// |+++ ----- STS   (000=ҋ@8192Xe[g)
									// +--- ----- SSBY  (0=X[v[hɑJ)
									
	MSTCR.BYTE = 0x57;				// W[X^oCRg[WX^
									// 0101-0111 (0x57)
									// |||| |||+- MSTOP0 (1 = A/Dϊ                X^oC)
									// |||| ||+-- MSTOP1 (1 = tbVRg[ X^oC)
									// |||| |+--- MSTOP2 (1 = DMAC                     X^oC)
									// |||| +---- MSTOP3 (0 = SCI1                     ANeBu)
									// |||+ ----- MSTOP4 (1 = SCI0                     X^oC)
									// ||+- ----- MSTOP5 (0 = ITU                      ANeBu)
									// |+-- ----- U[u
									// +--- ----- PSTOP  (0 = NbNo   )
	// eVXe
	InitLCD();
	InitSCI();
	InitKey();

	// |[g5 (LED 1`2  P5-0`1)
	P5.DDR = 0x03;					// o͂ɐݒ
	P5.DR.BYTE = 0x00;
}

void LED1(int nOn)
{
	if(nOn == 1){
		P5.DR.BIT.B0 = 1;
	}else{
		P5.DR.BIT.B0 = 0;
	}
}

void LED2(int nOn)
{
	if(nOn == 1){
		P5.DR.BIT.B1 = 1;
	}else{
		P5.DR.BIT.B1 = 0;
	}
}

// 1msEGCg
//	ITU CH0gp
//
void wait_1ms()
{
	ITU0.TCR.BYTE = 0x20;		// ^C}Rg[WX^
								// 0010-0000 (0x20)
								// |||| |+++- TPSC  (0=NbN : ӂŃJEg)
								// |||+ +---- CKEG  (0=オGbWŃJEg)
								// |++- ----- CCLR  (1=GRARyA}b`ŃNA)
								// +--- ----- U[u
	ITU0.TSR.BYTE = 0xF8;
	ITU0.TIER.BYTE = 0xF8;		// ^C}C^vgCl[uWX^
								// 1111-1000 (0xF8)
								// |||| |||+- IMIEA (0=IMFAtO݋֎~)
								// |||| ||+-- IMIEB (0=IMFBtO݋֎~)
								// |||| |+--- OVIE  (0=OVFtO݋֎~)
	ITU0.TCNT = 0;
	ITU0.GRA = 16000;			// 1ms (16MHz)
	ITU.TSTR.BIT.STR0 = 1;
	while(ITU0.TSR.BIT.IMFA == 0)
		;
	ITU.TSTR.BIT.STR0 = 0;
}

// msEGCg
//	n : EGCg (ms)
void wait_ms(int n)
{
	int i;
	for(i=0; i<n; i++)
		wait_1ms();
}
