//	ʐM (SCI1)
//
//  STX`ETXɈ͂ꂽR}hƂ
//	zXg(PC)̃R}h́A擪 HXXX t
//	MPŨR}hɂ́A擪 CXXX t
//  XXX̓R}h̘A000`999ɂȂ
//  H001 - C001 ̂悤ɕK΂ŗpӂvɑ΂ĉԂ
//  ȉeR}h
//  [H001]	LCDNA
//  [H002]	LCDJ[\z[
//  [H003A] LCDGg[h
//		A : Gg[h2rbg
//	[H004A] LCDfBXvC
//		A : fBXvC3rbg
//	[H005AA]LCDJ[\
//		AA: J[\5rbg
//	[H006AA]LCDt@NVZbg
//		AA: t@NV6rbg
//	[H007AA]LCD CGRAM Address Set
//		AA: 7rbg
//	[H008AA]LCD DDRAM Address Set
//		AA: 8rbg
//	[H009`]LCD CGRAM/DDRAM Data Write
//		AA: 0x01`0x50܂łB`̃f[^
//		BB: 21oCgWriteData
//	[H011A]	LED_/
//		A : erbgLEDAŉʃrbgLED1 (1=_, 0=)
//	[C021A] ^NgSWԕ
//		A : erbgSWAŉʃrbgS1 (1=)
//	[C022AA] fBbvSWԕ
//		AA: erbgSWAŉʃrbg1 (1=ON)
//	[H023]	SWԊmF
//		 [C023ABB]
//			A : ^NgSW̏
//			BB: fBbvSW̏
//
//  A = 16i1AXL[ɒu
//	ʐMpobt@ɂ256byte蓖Ă
#include <300H/3048S.H>
#include <stdio.h>
#include <string.h>
#include <sysio.h>
#include "mb_test.h"
#include "LCD.h"
#include "sci.h"
#include "key_c.h"

#define STX		0x02
#define ETX		0x03

char g_szRecvBuffer[256];
char g_nSTX;
int g_nRecvIndex;
char g_szSendBuffer[256];
char g_nETX;
int g_nSendIndex;

static void RecvCmd();

void InitSCI()
{
	int i;

	g_nSTX = 0;
	g_nRecvIndex = 0;
	g_nETX = ETX;
	g_nSendIndex = 0;

	SCI1.SCR.BYTE = 0;

	SCI1.SMR.BYTE = 0x00;		// VA[hWX^
								// 0000-0000
								// |||| ||++- CKS  (0=)
								// |||| |+--- MP   (0=}`vZbT@\֎~)
								// |||| +---- STOP (0=1Xgbvrbg)
								// |||+ ----- O/E  (0=peB)
								// ||+- ----- PE   (0=peBrbgtAyу`FbN֎~)
								// |+-- ----- CHR  (0=LN^OX 8rbg)
								// +--- ----- C/A  (0=)

	SCI1.BRR = 25;				// rbg[gWX^
								// (VXeNbN16MHz, {[[g38400bps)

	i = 0;	// 1rbgԑҋ@(?)
	while(i < 3000)
		i++;

	SCI1.SCR.BYTE = 0xF0;		// VARg[WX^
								// 1111-0100 (0xF4)
								// |||| ||++- CKE  (0=,NbN)
								// |||| |+--- TEIE (1=MI݋)
								// |||| +---- MPIE (0=}`vZbT݋֎~)
								// |||+ ----- RE   (1=M\)
								// ||+- ----- TE   (1=M\)
								// |+-- ----- RIE  (1=Mf[^tAG[݋)
								// +--- ----- TIE  (1=Mf[^GveB݋)
	SCI1.SSR.BYTE = 0x80;
	SCI1.SSR.BIT.TDRE = 0;


	sprintf(g_szSendBuffer, "C999");
	SendCmd();
}

// MG[	݃xN^56
//
void interrupt SCI1RecvErr()
{
	SCI1.SSR.BIT.ORER = 0;
	SCI1.SSR.BIT.FER = 0;
	SCI1.SSR.BIT.PER = 0;
}

// Mf[^t	݃xN^57
//
void interrupt SCI1RecvFull()
{
	char cData;

	cData = SCI1.RDR;
	SCI1.SSR.BIT.RDRF = 0;

	if(g_nSTX == STX){
		if(cData == ETX){
			// R}hM
			g_szRecvBuffer[g_nRecvIndex] = '\0';
			if(g_nRecvIndex >= 4){
				RecvCmd();
			}
			g_nSTX = 0;
			g_nRecvIndex = 0;
		}else{
			g_szRecvBuffer[g_nRecvIndex] = cData;
			g_nRecvIndex++;
		}
	}else{
		if(cData == STX){
			g_nSTX = STX;
		}
	}
}

// Mf[^GveB	݃xN^58
//
void interrupt SCI1SendEmpty()
{
	if(g_nETX == 0){
		if(g_szSendBuffer[g_nSendIndex] != '\0'){
			SCI1.TDR = g_szSendBuffer[g_nSendIndex];
			g_nSendIndex++;
		}else{
			g_nETX = ETX;
			SCI1.TDR = ETX;
			g_nSendIndex = 0;
		}
		SCI1.SSR.BIT.ORER = 0;
		SCI1.SSR.BIT.FER = 0;
		SCI1.SSR.BIT.PER = 0;
		SCI1.SSR.BIT.TDRE = 0;
	}else{
		SCI1.SCR.BIT.TIE = 0;
	}
}

// MI	݃xN^59
//
void interrupt SCI1SendEnd()
{
	SCI1.SSR.BIT.TEND = 0;
}

// R}hM
void RecvCmd()
{
	char szFld[5];
	int nCmd;
	unsigned int nParam, nParam2;
	unsigned char cData;
	char szBuffer[256];
	int i, nIdx;
	char cDIP, cSW;

	if(g_szRecvBuffer[0] == 'H'){
		strncpy(szFld, &g_szRecvBuffer[1], 3);
		szFld[3] = '\0';
		sscanf(szFld, "%d", &nCmd);
		switch(nCmd){
		case 1:		// LCDNA
			LCD_Clear();
			strcpy(g_szSendBuffer, "C001");
			SendCmd();
			break;
		case 2:		// LCDJ[\z[
			LCD_Home();
			strcpy(g_szSendBuffer, "C002");
			SendCmd();
			break;
		case 3:		// LCDGg[h
		case 4:		// LCDfBXvC
			strncpy(szFld, &g_szRecvBuffer[4], 1);
			szFld[1] = '\0';
			sscanf(szFld, "%x", &nParam);
			if(nCmd == 3)
				cData = 0x04 | ((char)nParam & 0x03);
			else
				cData = 0x08 | ((char)nParam & 0x07);
			LCD_Out(cData);
			sprintf(g_szSendBuffer, "C%03d", nCmd);
			SendCmd();
			break;
		case 5:		// LCDJ[\
		case 6:		// LCDt@NVZbg
		case 7:		// LCD CGRAM Address Set
		case 8:		// LCD DDRAM Address Set
			strncpy(szFld, &g_szRecvBuffer[4], 2);
			szFld[2] = '\0';
			sscanf(szFld, "%x", &nParam);
			if(nCmd == 5)
				cData = 0x10 | ((unsigned char)nParam & 0x0F);
			else if(nCmd == 6)
				cData = 0x20 | ((unsigned char)nParam & 0x1F);
			else if(nCmd == 7)
				cData = 0x40 | ((unsigned char)nParam & 0x3F);
			else
				cData = 0x80 | ((unsigned char)nParam & 0x7F);
			LCD_Out(cData);
			sprintf(g_szSendBuffer, "C%03d", nCmd);
			SendCmd();
			break;
		case 9:		// LCD CGRAM/DDRAM Data Write
			strncpy(szFld, &g_szRecvBuffer[4], 2);
			szFld[2] = '\0';
			sscanf(szFld, "%x", &nParam);
			nIdx = 0;
			for(i=0; i<(nParam * 2); i+=2){
				strncpy(szFld, &g_szRecvBuffer[6+i], 2);
				szFld[2] = '\0';
				sscanf(szFld, "%x", &nParam2);
				szBuffer[nIdx] = (char)nParam2;
				nIdx++;
			}
			szBuffer[nIdx] = '\0';
			LCD_Print(szBuffer, nParam);
			strcpy(g_szSendBuffer, "C009");
			SendCmd();
			break;
		case 11:	// LED_/
			strncpy(szFld, &g_szRecvBuffer[4], 1);
			szFld[1] = '\0';
			sscanf(szFld, "%d", &nParam);
			if(nParam & 0x01){
				LED1(1);
			}else{
				LED1(0);
			}
			if(nParam & 0x02){
				LED2(1);
			}else{
				LED2(0);
			}
			strcpy(g_szSendBuffer, "C011");
			SendCmd();
			break;
		case 21:	// ^NgSWԕ񍐉
			break;
		case 22:	// fBvSWԕ񍐉
			break;
		case 23:	// fBbvSWԊmF
			cDIP = GetDIP();
			cSW = GetSW();
			sprintf(g_szSendBuffer, "C023%1X%02X", cSW, cDIP);
			SendCmd();
			break;
		default:
			strcpy(g_szSendBuffer, g_szRecvBuffer);
			SendCmd();
			break;
		}
	}else{
		strcpy(g_szSendBuffer, g_szRecvBuffer);
		SendCmd();
	}
}

// R}hM
void SendCmd()
{
	while(g_nSendIndex != 0)
		;
	while(SCI1.SSR.BIT.TDRE == 0)
		;
	g_nETX = 0;
	SCI1.TDR = STX;
	SCI1.SSR.BIT.ORER = 0;
	SCI1.SSR.BIT.FER = 0;
	SCI1.SSR.BIT.PER = 0;
	SCI1.SSR.BIT.TDRE = 0;
	SCI1.SCR.BIT.TIE = 1;
}
